<!DOCTYPE html>
<html lang="en">

<head>
  <title>Task 34.40</title>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1">
  <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
  <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
  <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
</head>

<body onload="onPageLoading()">
  <div class="container">
    <div class="text-center mt-3 mb-3">
      <h2>F100 - Quản trị người dùng</h2>
    </div>
    <div class="jumbotron container">        
        <div class="row form-group">
          <label class="col-sm-2 col-form-label" for="firstNameInput">First name</label>
          <div class="col-sm-3">
              <input type="text" id="firstNameInput" class="form-control" placeholder="Nhap first name ...">
          </div>
          <label class="col-sm-2 col-form-label" for="lastNameInput">Last name</label>
          <div class="col-sm-3">
              <input type="text" id="lastNameInput" class="form-control" placeholder="Nhap last name ...">
          </div>
          <div class="col-sm-2">
            <button class="btn btn-success" id="btn-filter">Filter user</button>
          </div>
        </div>
    </div>
  </div>

  <div class="container mt-2">
    <div class="row">
      <div class="col-12 text-nowrap">
        <table id="table-users" class="table table-bordered table-striped table-hover">
          <thead>
            <tr>
              <th>Mã người dùng</th>
              <th>Firstname</th>
              <th>Lastname</th>
              <th>Country</th>
              <th>Subject</th>
              <th>Customer Type</th>
              <th>Register Status</th>
              <th>Action</th>
            </tr>
          </thead>
          <tbody>
            
          </tbody>
        </table>
      </div>
    </div>
  </div>
</body>
​
<script>
  "use strict";
  /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
  var gUsersArr = [];

  /*** REGION 2 - Vùng gán / thực thi hàm xử lý sự kiện cho các elements */
  
  //gán event handler (sự kiện) click và hàm thực thi khi nhấn nút filter user
  $("#btn-filter").on("click", onBtnFilterClick);
  //gán event handler (sự kiện) click và hàm thực thi khi nhấn nút chi tiết
  $("#table-users").on('click', '.btn-detail', function() {
    onBtnDetailClick(this);
  });
  /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
  //ham xu lý sự kiện click nut chi tiet
  function onBtnDetailClick(paramBtnDetail) {
    "use strict";
    var vCurrentRow = $(paramBtnDetail).closest("tr");
    var vUserID = $(vCurrentRow).find("td:eq(0)").text();
    console.log("Mã người dùng (Id): " + vUserID);
    alert("Mã người dùng (Id): " + vUserID);
  }
  /**
   * Call API để get all users và lưu vào mảng toàn cục gUsersArr.
   * gUsersArr được sử dụng cho mục đích filter về sau
  */
  // Hàm thực thi khi load trang
  function onPageLoading() {
    // gọi api load dữ liệu users
    $.ajax({
      url: 'http://203.171.20.210:8080/devcamp-register-java-api/users',
      type: 'GET',
      dataType: 'json',
      async: false, //thêm tham số async-false
      success: function (paramObjectUser) {
        gUsersArr = paramObjectUser;
      }
    });

    // gọi hàm để load dữ liệu mảng users vào table
    fillDataTableUser(gUsersArr);
    
  }
    
  /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/    
  //hàm thu thập dữ liệu
  function readData(paramKeyWordObj) {
    "use strict";
    var vInpFirstName = $("#firstNameInput");
    var vInpLastName = $("#lastNameInput");
    paramKeyWordObj.firstname = $.trim(vInpFirstName.val());
    paramKeyWordObj.lastname = $.trim(vInpLastName.val());
  }
  /* Hàm xử lý viec tìm kiếm user
    - input/start: paramkeyWordObj là 1 object chưa các keyword đã thu thập từ form fisrtname và lastname
    -output/end: trả về 1 arr gồm các object(user)
  */
 function findUserByFilter(paramKeyWordObj) {
  "use strict";
  const bArrResultObj=[];
  //kiểm tra trường hợp nếu firstname và lastname đều đc nhập
  if(paramKeyWordObj.firstname != "" && paramKeyWordObj.lastname != "") {
    for (let bI = 0; bI < gUsersArr.length; bI++) {
      const bItemUserObj = gUsersArr[bI];
      //thuc hien so sanh từ khóa đc nhập vào với dữ liệu user
      if (paramKeyWordObj.firstname.toLowerCase() ===bItemUserObj.firstname.toLowerCase() &&
      paramKeyWordObj.lastname.toLowerCase() === bItemUserObj.lastname.toLowerCase()) {
        //thêm đối tượng thỏa mãn dkien vao arr
        bArrResultObj.push(bItemUserObj);
      }
    }
  }
  return bArrResultObj;
 }
  /**
   * Hàm load data vào table
   * Input: mảng users
   * Output: table có dữ liệu
   */ 
  function fillDataTableUser(paramObjectUser) {
    var vUserTable = $('#table-users');
    for (var bI = 0; bI < paramObjectUser.length; bI++) {
      var bNewRow = $('<tr/>').appendTo(vUserTable);
      var bId = $('<td/>', {
        html: paramObjectUser[bI].id
      }).appendTo(bNewRow);

      var vFirstName = $('<td/>', {
        html: paramObjectUser[bI].firstname
      }).appendTo(bNewRow);

      var vLastName = $('<td/>', {
        html: paramObjectUser[bI].lastname
      }).appendTo(bNewRow);

      var vCountry = $('<td/>', {
        html: paramObjectUser[bI].country
      }).appendTo(bNewRow);

      var vSubject = $('<td/>', {
        html: paramObjectUser[bI].subject
      }).appendTo(bNewRow);

      var vCustomerType = $('<td/>', {
        html: paramObjectUser[bI].customerType
      }).appendTo(bNewRow);

      var vRegisterStatus = $('<td/>', {
        html: paramObjectUser[bI].registerStatus
      }).appendTo(bNewRow);

      var vAction = $('<td/>').appendTo(bNewRow);
      var vDetailButon = $("<button/>", {
        text: "Chi tiết"
      }).addClass("btn btn-primary btn-detail")
        .appendTo(vAction);
    }
  }
  //hàm xu ly su kien khi ấn nut filter user
  function onBtnFilterClick(params) {
    "use strict";
    //B1: tạo đối tượng để truyền qua các bước
    var vFilterObj = {
      firstname:"",
      lastname:""
    }
    //B2: thu thập dữ liệu
    readData(vFilterObj);
    //B3: validate du lieu
    //B4: thuc hiện việc tìm kiếm và xử lý hiển thị
    var vArrUserFiltered = findUserByFilter(vFilterObj);
    var vTable = $("#table-users");  // truy vấn đén bảng có id="table-users"
    vTable.find("tr:gt(0)").html('');  //xóa trắng bảng (ko xóa head)
    if (vArrUserFiltered.length > 0) {
      //hiên thong bao da tim đc
      alert('tìm thấy ' + vArrUserFiltered.length + ' kết quả phù hợp!');
      //hiên thị danh sách dữ liệu tìm đc ra table
      fillDataTableUser(vArrUserFiltered);
    } else {
      alert('Không tìm thấy kết quả phù hợp');
      return false;
    }
  }

</script>

</html>
​